﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SequencionReader.SequencionTypes
{
    public class AritmeticSequencion : ISequencion
    {
        public double[] Compute(double[] sequencion, int number)
        {
            double[] result = null;
            if (sequencion.Count() > 1)
            {
                result = new double[number];
                double difference = Math.Abs(sequencion[1] - sequencion[0]);
                double firstItem = sequencion[0];

                bool decreasing = sequencion[1] < sequencion[0];

                int n = sequencion.Length;

                for (int i = 0; i < result.Length; i++)
                {
                    double rightSide = n * difference;
                    if (decreasing) rightSide *= -1;
                    result[i] = firstItem + rightSide;
                    n++;
                }

            }
            return result;
        }
        public bool Is(double[] sequencion)
        {
            bool result = false;
            if (sequencion.Count() > 1)
            {
                double difference = Math.Abs(sequencion[1]) - Math.Abs(sequencion[0]);
                for (int i = 1; i < sequencion.Length - 1; i++)
                {
                    double tempDifference = Math.Abs(sequencion[i + 1]) - Math.Abs(sequencion[i]);
                    if (difference != tempDifference) return false;
                }
                result = true;
            }
            return result;
        }
    }
}
