﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SequencionReader.SequencionTypes
{
    class ConstantSequencion : ISequencion
    {
        public double[] Compute(double[] sequencion, int number)
        {
            double[] result = null;
            if (sequencion.Count() > 1)
            {
                double item = sequencion[0];
                result = new double[number];
                bool first = item > sequencion[1];

                for (int i = 1; i <= result.Length; i++)
                {
                    if (i % 2 != 0) result[i - 1] = first ? item : item * (-1);
                    else result[i - 1] = first ? item * (-1) : item;
                }
            }
            return result;
        }

        public bool Is(double[] sequencion)
        {
            bool result = false;
            if (sequencion.Count() > 1)
            {
                double value = Math.Abs(sequencion[0]);
                for (int i = 1; i < sequencion.Length; i++)
                    if (Math.Abs(sequencion[i]) != value) return false;
                result = true;
            }
            return result;
        }
    }
}
